/*
 * file: NrSpeedCalc.cpp
 *
 * This file is part of the NetStreamer software. This file is distributed
 * under the GNU GENERAL PUBLIC LICENSE, see the accompanying COPYING file.
 *
 * Copyright (C) 1997 Rolf Fokkens
 *
 */

#include <iostream.h>
#include "NrSpeedCalc.h"

void NrSpeedCalc::Reset (void)
{
    MsCalcStart = 0;
};

void NrSpeedCalc::AddData (long Amount, long MsCurTime)
{
    MsCalcLast = MsCurTime;

    if (MsCalcStart == 0) {
        MsCalcStart = MsCurTime;
        CalcAmount  = 0;
    } else {
        CalcAmount += Amount;
    };

    if (CalcAmount > 500000) {
        CalcAmount  = (CalcAmount) >> 1;
        MsCalcStart = (MsCalcStart + MsCurTime) >> 1;
    };
};

long NrSpeedCalc::GetAvgSpeed (int ShLeft)
{
    long RetVal;

    if (MsCalcStart == 0 || MsCalcLast == MsCalcStart) return 0;

    RetVal = (CalcAmount << ShLeft) / (MsCalcLast - MsCalcStart);

    return RetVal;
};
